<?php if(!defined('PLX_ROOT')) exit;
/**
 * Plugin plxResponsiveSlidesJs
 * @author Stephane F
 * @fourcheur Thomas Ingles
 **/
   include_once(dirname(__FILE__).'/lib/class.plx.responslidesjs.php');

class plxResponsiveSlidesJs extends plxPlugin {
 const V = '1.2.3';
 public $responslidesjs = null; # objet responslidesjs
 public $menuName = null;
 public function __construct($default_lang){
  #include_once(dirname(__FILE__).'/lib/class.plx.responslidesjs.php');
  parent::__construct($default_lang);# appel du constructeur de la classe plxPlugin (obligatoire)
  $this->setAdminProfil(PROFIL_ADMIN, PROFIL_MANAGER);# Autorisation d'accès à l'administration du plugin#, PROFIL_MODERATOR, PROFIL_EDITOR, PROFIL_WRITER
  $this->setConfigProfil(PROFIL_ADMIN, PROFIL_MANAGER);# Autorisation d'acces à la configuration du plugin
   #var_dump($this, dirname(__FILE__).'/lib/class.plx.responslidesjs.php');
  $this->responslidesjs = new responslidesjs();
  $this->responslidesjs->getSlides();
# Personnalisation du menu
  $this->menuName = $this->getParam('menu')!='' ? $this->getParam('menu') : __CLASS__;
  $this->setAdminMenu(
   $this->menuName
   , $this->getParam('posm')!='0' ? $this->getParam('posm') : null
   , $this->getInfo('description')
  );
  if(defined('PLX_ADMIN')){#Déclaration des hooks pour la zone d'administration
   $this->addHook('AdminMediasTop', 'AdminMediasTop');
   $this->addHook('AdminMediasPrepend', 'AdminMediasPrepend');
   if(isset($_SERVER['QUERY_STRING']) AND $_SERVER['QUERY_STRING'] == 'p='.__CLASS__){#pour lui seul
    $this->addHook('AdminTopEndHead', 'AdminTopEndHead');
    $this->addHook('AdminFootEndBody', 'AdminFootEndBody');
   }
  }else{#Déclaration des hooks pour la partie visiteur
   if($this->responslidesjs->aSlides){
    $this->addHook('ThemeEndHead', 'ThemeEndHead');
    $this->addHook('ThemeEndBody', 'ThemeEndBody');
    $this->addHook('ResponsiveSlidesJs', 'ResponsiveSlidesJs');
   }
  }
 }
 public function AdminTopEndHead() {# Insertion du css overide 5.6
  echo ' <link defer rel="stylesheet" type="text/css" href="'.PLX_PLUGINS.__CLASS__.'/admin.css?v='.self::V.'" media="screen" />';
 }
 public function AdminFootEndBody() {# Insertion du js overide title 5.6
  echo ' <script defer type="text/javascript" src="'.PLX_PLUGINS.__CLASS__.'/admin.js?v='.self::V.'"></script>';
 }
 public function AdminMediasTop(){# Insertion du ajouter au diaporama (menu media)
  echo '<?php
  $arr = array("ResponsiveSlidesJs" => array("responslidesjs_add" => "'.$this->getLang('L_ADD').' ('.$this->menuName.')"));
  $selectionList = array_merge($selectionList, $arr);
  ?>';
 }
 public function AdminMediasPrepend(){# Sauver les images sélectionnées (menu media)
  if(isset($_POST['selection']) AND ($_POST['selection'] == 'responslidesjs_add') AND isset($_POST['idFile'])){
   $this->responslidesjs->editSlides($_POST);
   header('Location: medias.php');
   exit;
  }
 }
 public function ResponsiveSlidesJs(){# Hook qui affiche le diapo
  echo '
  <div class="rslides_container '.$this->getParam('loadClass').'">
   <ul class="rslides" id="responsiveslides">';
  $i=0;
  foreach($this->responslidesjs->aSlides as $slide){//si images actives
   if($slide['active']){
    $url = plxUtils::strCheck($slide['url']);
    $title = plxUtils::strCheck($slide['title']);
    $desc = strip_tags($slide['description']);
    $lazy = $this->getParam('lazy');
    $jazy = $this->getParam('jazy');
    $fill = '<img class="rslidesfill '.($lazy?' '.$jazy.'" data-':'" ').'src="'.$url.'" title="'.$title.'" alt="'.$desc.'" />'
    .($i==0&&$lazy?'<noscript><img class="rslidesfill" src="'.$url.'" title="'.$title.'" alt="'.$desc.'" /></noscript>':'');
    if($this->getParam('fill'))
     $fill = '<div class="rslidesfill'.($lazy?' '.$jazy.'" data-src="':'" style="background-image:url(\'').plxUtils::getRacine().$url.($lazy?'':'\');').'">'
     .($i==0&&$lazy?'<noscript><div class="rslidesfill" style="background-image:url(\''.plxUtils::getRacine().$url.'\');"></div></noscript>':'')
     .'</div>';
    if($slide['description']!='')$fill .= '
      <p class="caption">'.strip_tags($slide['description'], '<strong><b><em><br>').'</p>';
    if($slide['onclick']!='')$fill = '
     <a href="'.plxUtils::strCheck($slide['onclick']).'">
      '.$fill.'
     </a>';
    elseif($this->getParam('lynx')!='0')$fill = '
     <a href="'.$url.'">
      '.$fill.'
     </a>';
    echo '
    <li title="'.$title.'">'.$fill.'
    </li>';
    $i=1;//noscript only 4 the 1st ;)
   }
  }
  echo "
   </ul>
  </div>\n";
 }
 public function ThemeEndHead(){
  echo '<link defer rel="stylesheet" type="text/css" href="'.PLX_PLUGINS.__CLASS__.'/responsiveslides/responsiveslides-styles.css?v='.self::V.'" media="screen,print" />'."\n";
  echo '<style type="text/css">'."\n".
   "\t".'.rslides_container, .rslides_container .rslidesfill{ width:'.$this->getParam('width').'; height:'.$this->getParam('height').'; max-width:'.$this->getParam('maxwidth').'; max-height:'.$this->getParam('maxheight').'; }'."\n".
   "</style>\n";
 }
 public function ThemeEndBody(){
  if ($this->getParam('jquery')==1){
   echo '<script type="text/javascript" src="'.PLX_PLUGINS.__CLASS__.'/responsiveslides/jquery-3.5.1.min.js"></script>'.PHP_EOL;
  }
?><script type="text/javascript" src="<?=PLX_PLUGINS.__CLASS__?>/responsiveslides/responsiveslides.1.55.lazy.min.js?v=<?=self::V?>"></script>
<?php
  $keys = array('speed','pager','timeout','prevText','nextText','auto','namespace','nav','random','pause','pauseControls','lazy');
  $array = array();
  $parms = $this->getParams();
  foreach($parms as $key => $value){
   if(in_array($key, $keys) AND ($value['value']!='' OR $value['value']==1)){
    if(in_array($key, array('nav','random','pause')))
     $array[] = $key.':'.($value['value']==1?'true':'false');
    elseif($value['type']=='numeric')
     if($key=='lazy'&&$value['value']==1)
      $array[] = $key.":'".$this->getParam('jazy')."'";//Transmet lazy className
     else
      $array[] = $key.':'.$value['value'];
    else
     $array[] = $key.":'".$value['value']."'";
   }
  }
  $string = $array ? implode(',',$array) : '';
?>
<script type="text/javascript">
$(document).ready(function(){
 $('#responsiveslides').responsiveSlides({<?=$string?>});
});
window.setTimeout(function(){$('.rslides_container').removeClass('<?= $this->getParam('loadClass')?>');},<?=(int)$this->getParam('remClassLoad')?>);
</script>
<?php
 }
}